//
//  SubViewController.swift
//  demo5-抽屉效果
//
//  Created by zero on 16/12/23.
//  Copyright © 2016年 yunhaitechnology. All rights reserved.
//

import UIKit

class SubViewController: UIViewController,UITableViewDataSource,UITableViewDelegate {
    let tableview = UITableView.init()
    let SCREEN_WIDTH = UIScreen.main.bounds.size.width
    let SCREEN_HEIGHT = UIScreen.main.bounds.size.height
    var dataSouce:NSMutableArray = ["1","2","3","4","5","6","7","8","11","12","13","14","15","16","17","18"]
    var deleteArr:NSMutableArray = []
    override func viewDidLoad() {
        super.viewDidLoad()
        setupTableview()
        setupNavigationBar()
    }
    func setupNavigationBar() -> Void {
        let editButton = UIBarButtonItem.init(title: "编辑", style: .done, target: self, action: #selector(buttonDidTouch))
        let doneButton = UIBarButtonItem.init(title: "完成", style: .done, target: self, action: #selector(buttonDidTouch))
        let deleteButton = UIBarButtonItem.init(title: "删除", style: .done, target: self, action: #selector(buttonDidTouch))
        let selectAllButton = UIBarButtonItem.init(title: "全选", style: .done, target: self, action: #selector(buttonDidTouch))
        let resetAllButton = UIBarButtonItem.init(title: "重置", style: .done, target: self, action: #selector(buttonDidTouch))
        editButton.tag = 1001
        doneButton.tag = 1002
        deleteButton.tag = 1003
        selectAllButton.tag = 1004
        self.navigationItem.leftBarButtonItems = [editButton,doneButton,deleteButton,selectAllButton,resetAllButton]
    }
    func buttonDidTouch(btn:UIButton) -> Void {
        if btn.tag == 1001 {//编辑
            tableview.isEditing = true
            tableview.allowsMultipleSelectionDuringEditing = true
        }else if btn.tag == 1002{//完成
           tableview.isEditing = false
        }else if btn.tag == 1003 {//删除
//            self.dataSouce.remove(self.deleteArr as [AnyObject])
            self.dataSouce.removeObjects(in: self.deleteArr as [AnyObject])
            tableview.reloadData()
        }else if btn.tag == 1004{//全选
            if tableview.isEditing == false {//如果处于完成状态则直接返回
                return
            }
            for row in 0...self.dataSouce.count {
                let indexPath = IndexPath.init(row: row,section:0)
                tableview.selectRow(at: indexPath, animated: false, scrollPosition: .none)
            }
            self.deleteArr.addObjects(from: self.dataSouce as [AnyObject])
        }else{
            self.dataSouce = ["1","2","3","4","5","6","7","8","11","12","13","14","15","16","17","18"]
            self.tableview.reloadData()
        }
    }
    func setupTableview() -> Void {
        tableview.frame = CGRect(x: 0, y: 0, width: SCREEN_WIDTH, height: SCREEN_HEIGHT)
        tableview.delegate = self;
        tableview.dataSource = self
        self.view.addSubview(tableview)
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.dataSouce.count
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = UITableViewCell.init(style: .default, reuseIdentifier: "UITableViewCell")
        cell.textLabel?.text = self.dataSouce[indexPath.row] as? String
        return cell
    }
    //    设置编辑style
    func tableView(_ tableView: UITableView, editingStyleForRowAt indexPath: IndexPath) -> UITableViewCellEditingStyle {
        return UITableViewCellEditingStyle.init(rawValue: UITableViewCellEditingStyle.delete.rawValue | UITableViewCellEditingStyle.insert.rawValue)!
    }
    //    选中则添加到删除数组中
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        self.deleteArr.add(self.dataSouce[indexPath.row])
    }
    //    取消选中在数组中删除
    func tableView(_ tableView: UITableView, didDeselectRowAt indexPath: IndexPath) {
        self.deleteArr.remove(self.dataSouce[indexPath.row])
    }
    
}
